"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Core =
/*#__PURE__*/
function () {
  function Core() {
    _classCallCheck(this, Core);

    this._runningPtext;
    this._runningFileId;
    this._callbacks;
    this._interval;
    this._isPaused;
  }

  _createClass(Core, [{
    key: "findAndCountPomodoroText",
    value: function findAndCountPomodoroText(text, fileId) {
      var callbacks = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      this._callbacks = callbacks;

      var ptext = this._findPomodoroText(text, fileId);

      if (this._runningPtext && ptext.operator === this._runningPtext.operator && ptext.time === this._runningPtext.time && ptext.content === this._runningPtext.content && this._runningFileId === fileId) {
        return;
      }

      if (ptext) {
        if (!this._runningPtext || ptext.time !== this._runningPtext.time || ptext.content !== this._runningPtext.content || this._runningFileId !== fileId) {
          if (this._interval) {
            clearInterval(this._interval);
            this._interval = null;
            callbacks.cancel && callbacks.cancel();
          }

          callbacks.start && callbacks.start(ptext);

          var intervalCallback = function intervalCallback(remaining) {
            callbacks.interval && callbacks.interval(remaining, ptext);
          };

          this._startTimer(ptext.time, intervalCallback).then(function () {
            return callbacks.finish && callbacks.finish(ptext);
          });
        }

        this._runningPtext = ptext;
        this._runningFileId = fileId;

        if (ptext.operator === '-') {
          this._isPaused = true;
          return;
        } else if (this._isPaused) {
          this._isPaused = false;
          return;
        }
      } else {
        this._runningPtext = null;

        if (!this._runningFileId || fileId === this._runningFileId) {
          this._clearTimer();

          callbacks.cancel && callbacks.cancel();
        }
      }
    }
  }, {
    key: "_findPomodoroText",
    value: function _findPomodoroText(text, id) {
      var lines = text.split('\n');
      var lineNumber = 0;
      var found;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = lines[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var line = _step.value;
          found = line.match(/(?:^|^ *(?:-|\*) |^ *(?:-|\*) \[ \] )\[(-|)p([0-9].*)\] *(.+)/);

          if (found != null) {
            return {
              id: id,
              line: lineNumber,
              operator: found[1],
              time: parseInt(found[2]) * 60,
              content: found[3]
            };
          }

          lineNumber++;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return false;
    }
  }, {
    key: "_startTimer",
    value: function _startTimer(timeSec, callback) {
      var _this = this;

      return new Promise(function (resolve) {
        _this._interval = setInterval(function () {
          if (_this._isPaused) return;
          callback(--timeSec);

          if (timeSec <= 0) {
            clearInterval(_this._interval);
            _this._interval = null;
            resolve();
          }
        }, 1000);
      });
    }
  }, {
    key: "_clearTimer",
    value: function _clearTimer() {
      clearInterval(this._interval);
      this._interval = null;
      this._isPaused = false;
    }
  }, {
    key: "stopTimer",
    value: function stopTimer() {
      if (this._runningPtext == null) return;
      this._runningPtext = null;

      this._clearTimer();

      this._callbacks.cancel && this._callbacks.cancel();
    }
  }, {
    key: "retryLatest",
    value: function retryLatest() {
      var _this2 = this;

      if (this._runningPtext == null) return;

      this._clearTimer();

      this._callbacks.start && this._callbacks.start(this._runningPtext);

      var intervalCallback = function intervalCallback(remaining) {
        _this2._callbacks.interval && _this2._callbacks.interval(remaining, _this2._runningPtext);
      };

      this._startTimer(this._runningPtext.time, intervalCallback).then(function () {
        return _this2._callbacks.finish && _this2._callbacks.finish(_this2._runningPtext);
      });

      if (this._runningPtext.operator === '-') {
        this._isPaused = true;
      }
    }
  }]);

  return Core;
}();

exports.default = Core;